<template>
    <AdminMenuBar>
        <div class="flex items-center items-justify">
        <resourceForm
            :formFields="formFields"
            :isEditing="isEditing"
            :method="method"
            :url="url"
            :getSingleData="getSingleData"
            :picturePreview="picturePreview"
            :available="available"
        ></resourceForm>
        </div>
    </AdminMenuBar>
</template>

<script setup>
import { useRoute } from "vue-router";
import { ref, onMounted } from "vue";
import resourceForm from "../form/resourceForm.vue";
import formHelper from "../../helpers/form";
import itemHandler from "../../helpers/itemHandler";

const { fetchItem } = itemHandler;

const route = useRoute();
const { form, rules } = formHelper;
const isEditing = ref(true);
const method = "POST";
const url = ref("/api/user/item/" + route.params.id);
const formFields = ref([
    {
        prop: "name",
        label: "Product name",
        rules: [rules.required],
        type: "input",
    },
    {
        prop: "price",
        label: "Price",
        rules: [rules.number],
        type: "input-number",
    },
    {
        prop: "description",
        label: "Description",
        rules: [rules.required],
        type: "textarea",
    },
    {
        prop: "quantity",
        label: "Quantity",
        rules: [rules.number],
        type: "input-number",
    },
]);

const fetchedData = ref([]);
const picturePreview = ref();
const available = ref();

const getSingleData = async () => {
    const URL_fetch_single = "/api/user/item/" + route.params.id;
    await fetchItem(URL_fetch_single, fetchedData);
    form.value = fetchedData.value.data.attributes;
    picturePreview.value = '/pictures/' + fetchedData.value.data.attributes.img_url;
   
    available.value = fetchedData.value.data.attributes.available ? true : false;
};
onMounted(async () => {
    getSingleData();
});
</script>
